<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>RESIF: RESIFWS: PH5-availability Docs: v1</title>
  <style>
    html {
      line-height: 1.5;
      font-family: Georgia, serif;
      font-size: 20px;
      color: #1a1a1a;
      background-color: #fdfdfd;
    }
    body {
      margin: 0 auto;
      max-width: 36em;
      padding-left: 50px;
      padding-right: 50px;
      padding-top: 50px;
      padding-bottom: 50px;
      hyphens: auto;
      overflow-wrap: break-word;
      text-rendering: optimizeLegibility;
      font-kerning: normal;
    }
    @media (max-width: 600px) {
      body {
        font-size: 0.9em;
        padding: 1em;
      }
      h1 {
        font-size: 1.8em;
      }
    }
    @media print {
      body {
        background-color: transparent;
        color: black;
        font-size: 12pt;
      }
      p, h2, h3 {
        orphans: 3;
        widows: 3;
      }
      h2, h3, h4 {
        page-break-after: avoid;
      }
    }
    p {
      margin: 1em 0;
    }
    a {
      color: #1a1a1a;
    }
    a:visited {
      color: #1a1a1a;
    }
    img {
      max-width: 100%;
    }
    h1, h2, h3, h4, h5, h6 {
      margin-top: 1.4em;
    }
    h5, h6 {
      font-size: 1em;
      font-style: italic;
    }
    h6 {
      font-weight: normal;
    }
    ol, ul {
      padding-left: 1.7em;
      margin-top: 1em;
    }
    li > ol, li > ul {
      margin-top: 0;
    }
    blockquote {
      margin: 1em 0 1em 1.7em;
      padding-left: 1em;
      border-left: 2px solid #e6e6e6;
      color: #606060;
    }
    code {
      font-family: Menlo, Monaco, 'Lucida Console', Consolas, monospace;
      font-size: 85%;
      margin: 0;
    }
    pre {
      margin: 1em 0;
      overflow: auto;
    }
    pre code {
      padding: 0;
      overflow: visible;
      overflow-wrap: normal;
    }
    .sourceCode {
     background-color: transparent;
     overflow: visible;
    }
    hr {
      background-color: #1a1a1a;
      border: none;
      height: 1px;
      margin: 1em 0;
    }
    table {
      margin: 1em 0;
      border-collapse: collapse;
      width: 100%;
      overflow-x: auto;
      display: block;
      font-variant-numeric: lining-nums tabular-nums;
    }
    table caption {
      margin-bottom: 0.75em;
    }
    tbody {
      margin-top: 0.5em;
      border-top: 1px solid #1a1a1a;
      border-bottom: 1px solid #1a1a1a;
    }
    th {
      border-top: 1px solid #1a1a1a;
      padding: 0.25em 0.5em 0.25em 0.5em;
    }
    td {
      padding: 0.125em 0.5em 0.25em 0.5em;
    }
    header {
      margin-bottom: 4em;
      text-align: center;
    }
    #TOC li {
      list-style: none;
    }
    #TOC ul {
      padding-left: 1.3em;
    }
    #TOC > ul {
      padding-left: 0;
    }
    #TOC a:not(:hover) {
      text-decoration: none;
    }
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
<link rel="stylesheet" href="./static/resifws.css"/>
<a href="./local=fr"> <img src="./static/images/fr.png" alt="Anglais - Français"> </a>
</head>
<body>
<p style="text-align:center;"> <img src="./static/images/logoresif.png" alt="logoresif" width="341" height="95"></p>
<h1 id="webservice-ph5-availability">Webservice ph5-availability</h1>
<h2 id="description">Description</h2>
<p>The ph5-availability web service returns detailed timespan
information of what time series is available in the PH5 database.</p>
<p>There are two service query methods:</p>
<p>/extent</p>
<p>Produce a list of available time extents (earliest to latest) for
selected channels (network, station, location, channel and quality) and
time ranges.</p>
<p>/query</p>
<p>Produce a list of contiguous timespans for selected channels
(network, station, location, channel and quality) and time ranges.</p>
<h2 id="output-format-options">Output format options:</h2>
<ul>
<li>text</li>
<li>json</li>
<li>geocsv</li>
</ul>
<h2 id="query-usage">Query usage</h2>
<p>Query parameters are joined by ampersands “&amp;”, without blank
space (see the sample queries). Default values are uppercase. At least
one station or one network must be specified.</p>
<h3 id="extent-usage">/extent usage</h3>
<pre><code>/extent? [channel-options] [date-range-options] [merge-options] [sort-options] [display-options] [format-options] [nodata=404]

where :

channel-options      ::  [net=&lt;network&gt;] [sta=&lt;station&gt;] [loc=&lt;location&gt;] [cha=&lt;channel&gt;] [quality=&lt;quality&gt;]
date-range-options   ::  [starttime=&lt;date|duration&gt;] [endtime=&lt;date|duration&gt;]
merge-options        ::  [merge=&lt;quality|samplerate|overlap&gt;]
sort-options         ::  [orderby=&lt;NSLC_TIME_QUALITY_SAMPLERATE|timespancount|timespancount_desc|latestupdate|latestupdate_desc&gt;]
display-options      ::  [includerestricted=&lt;true|FALSE&gt;] [limit=&lt;number&gt;]
format-options       ::  [format=&lt;TEXT|geocsv|json|request|zip&gt;]

default values are uppercase</code></pre>
<h3 id="query-usage-1">/query usage</h3>
<pre><code>/query? [channel-options] [date-range-options] [merge-options] [sort-options] [display-options] [format-options] [nodata=404]

where :

channel-options      ::  [net=&lt;network&gt;] [sta=&lt;station&gt;] [loc=&lt;location&gt;] [cha=&lt;channel&gt;] [quality=&lt;quality&gt;]
date-range-options   ::  [starttime=&lt;date|duration&gt;] [endtime=&lt;date|duration&gt;]
merge-options        ::  [merge=&lt;quality|samplerate|overlap&gt;] [mergegaps=&lt;number&gt;]
sort-options         ::  [orderby=&lt;NSLC_TIME_QUALITY_SAMPLERATE|latestupdate|latestupdate_desc&gt;]
display-options      ::  [includerestricted=&lt;true|FALSE&gt;] [limit=&lt;number&gt;] [show=&lt;latestupdate&gt;]
format-options       ::  [format=&lt;TEXT|geocsv|json|request|zip&gt;]

default values are uppercase</code></pre>
<h2 id="sample-queries">Sample queries</h2>
<h3 id="with-extent">with /extent</h3>
<p><a href="http://ph5ws.resif.fr/resifws/availability/1/extent?net=3C&sta=N02,N08&start=2019-01-01&end=2020-01-01">http://ph5ws.resif.fr/resifws/availability/1/extent?net=3C&amp;sta=N02,N08&amp;start=2019-01-01&amp;end=2020-01-01</a></p>
<p><a href="http://ph5ws.resif.fr/resifws/availability/1/extent?net=3C&sta=N02,N08&start=2019-01-01&end=2020-01-01&show=latestupdate&orderby=timespancount">http://ph5ws.resif.fr/resifws/availability/1/extent?net=3C&amp;sta=N02,N08&amp;start=2019-01-01&amp;end=2020-01-01&amp;show=latestupdate&amp;orderby=timespancount</a></p>
<h3 id="with-query">with /query</h3>
<p><a href="http://ph5ws.resif.fr/resifws/availability/1/query?net=3C&sta=N02,N08&start=2019-01-01&end=2020-01-01">http://ph5ws.resif.fr/resifws/availability/1/query?net=3C&amp;sta=N02,N08&amp;start=2019-01-01&amp;end=2020-01-01</a></p>
<p><a href="http://ph5ws.resif.fr/resifws/availability/1/query?net=3C&sta=N02,N08&start=2019-01-01&end=2020-01-01&merge=samplerate&mergegaps=36000">http://ph5ws.resif.fr/resifws/availability/1/query?net=3C&amp;sta=N02,N08&amp;start=2019-01-01&amp;end=2020-01-01&amp;merge=samplerate&amp;mergegaps=36000</a></p>
<h2 id="detailed-descriptions-of-each-query-parameter">Detailed
descriptions of each query parameter</h2>
<h3 id="channel-options">Channel options</h3>
<table>
<colgroup>
<col style="width: 10%" />
<col style="width: 8%" />
<col style="width: 81%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">Parameter</th>
<th style="text-align: left;">Example</th>
<th style="text-align: left;">Discussion</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">net[work]</td>
<td style="text-align: left;">FR</td>
<td style="text-align: left;">Seismic network name. Accepts wildcards
and lists.</td>
</tr>
<tr class="even">
<td style="text-align: left;">sta[tion]</td>
<td style="text-align: left;">CIEL</td>
<td style="text-align: left;">Station name. Accepts wildcards and
lists.</td>
</tr>
<tr class="odd">
<td style="text-align: left;">loc[ation]</td>
<td style="text-align: left;">00</td>
<td style="text-align: left;">Location code. Use loc=-- for empty
location codes. Accepts wildcards and lists.</td>
</tr>
<tr class="even">
<td style="text-align: left;">cha[nnel]</td>
<td style="text-align: left;">HHZ</td>
<td style="text-align: left;">Channel Code. Accepts wildcards and
lists.</td>
</tr>
</tbody>
</table>
<h4 id="wildcards-and-lists">Wildcards and lists</h4>
<ul>
<li><p>Wildcards: the question mark <strong>?</strong> represents any
single character, while the asterisk <strong>*</strong> represents zero or more
characters.</p></li>
<li><p>List: multiple items may be retrieved using a comma-separated
list. Wildcards may be included in the list.</p></li>
</ul>
<p>For example, with channel codes: channel=EH?,BHZ</p>
<h3 id="date-range-options">Date-range options</h3>
<table>
<colgroup>
<col style="width: 11%" />
<col style="width: 19%" />
<col style="width: 69%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">Parameter</th>
<th style="text-align: left;">Example</th>
<th style="text-align: left;">Discussion</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">start[time]</td>
<td style="text-align: left;">2010-01-10T00:00:00</td>
<td style="text-align: left;">Selects timespan information on or after
the specified start time.</td>
</tr>
<tr class="even">
<td style="text-align: left;">end[time]</td>
<td style="text-align: left;">2011-02-11T01:00:00</td>
<td style="text-align: left;">Selects timespan information on or before
the specified end time.</td>
</tr>
</tbody>
</table>
<p>The definition of the time interval may take different forms:</p>
<ul>
<li>a calendar dates, for example starttime=2015-08-12T01:00:00</li>
<li>duration in seconds, for example endtime=7200</li>
<li>the key word “currentutcday” which means midnight of today’s date
(UTC time), for example starttime=currentutcday</li>
</ul>
<h3 id="merge-options">Merge options</h3>
<table>
<colgroup>
<col style="width: 15%" />
<col style="width: 10%" />
<col style="width: 73%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">Parameters</th>
<th style="text-align: left;">Examples</th>
<th style="text-align: left;">Discussion</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">merge</td>
<td style="text-align: left;"></td>
<td style="text-align: left;">Comma separated list (example
merge=quality,samplerate).</td>
</tr>
<tr class="even">
<td style="text-align: left;"></td>
<td style="text-align: left;">quality</td>
<td style="text-align: left;">The timespans of data with differing
quality are grouped together.</td>
</tr>
<tr class="odd">
<td style="text-align: left;"></td>
<td style="text-align: left;">samplerate</td>
<td style="text-align: left;">The timespans of data with differing
sample rates are grouped together.</td>
</tr>
<tr class="even">
<td style="text-align: left;"></td>
<td style="text-align: left;">overlap</td>
<td style="text-align: left;">Not applicable.</td>
</tr>
</tbody>
</table>
<h3 id="output-options">Output options</h3>
<table>
<colgroup>
<col style="width: 10%" />
<col style="width: 7%" />
<col style="width: 81%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">Parameters</th>
<th style="text-align: left;">Examples</th>
<th style="text-align: left;">Discussion</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">format</td>
<td style="text-align: left;">json</td>
<td style="text-align: left;">Specify the output format. Accepted values
are text (the default), json, request and zip.</td>
</tr>
<tr class="even">
<td style="text-align: left;">includerestricted</td>
<td style="text-align: left;">false</td>
<td style="text-align: left;">Display or not restricted data.</td>
</tr>
<tr class="odd">
<td style="text-align: left;">limit</td>
<td style="text-align: left;">integer</td>
<td style="text-align: left;">Limits output to this many rows.</td>
</tr>
<tr class="even">
<td style="text-align: left;">nodata</td>
<td style="text-align: left;">404</td>
<td style="text-align: left;">Specify which HTTP status code is returned
when no data is found (204 or 404)</td>
</tr>
</tbody>
</table>
<h3 id="sort-options">Sort options</h3>
<table>
<colgroup>
<col style="width: 8%" />
<col style="width: 23%" />
<col style="width: 67%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">Parameters</th>
<th style="text-align: left;">Examples</th>
<th style="text-align: left;">Discussion</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">orderby</td>
<td style="text-align: left;"></td>
<td style="text-align: left;">Sort rows by:</td>
</tr>
<tr class="even">
<td style="text-align: left;"></td>
<td style="text-align: left;">nslc_time_quality_samplerate</td>
<td style="text-align: left;">network, station, location, channel,
time-range, quality, sample-rate (default)</td>
</tr>
<tr class="odd">
<td style="text-align: left;"></td>
<td style="text-align: left;">latestupdate</td>
<td style="text-align: left;">update-date (past to present), network,
station, location, channel, time-range, quality, sample-rate</td>
</tr>
<tr class="even">
<td style="text-align: left;"></td>
<td style="text-align: left;">latestupdate_desc</td>
<td style="text-align: left;">update-date (present to past), network,
station, location, channel, time-range, quality, sample-rate</td>
</tr>
</tbody>
</table>
<h3 id="additional-parameters-for-the-extent-method">Additional
parameters for the extent method</h3>
<table>
<colgroup>
<col style="width: 9%" />
<col style="width: 16%" />
<col style="width: 73%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">Parameters</th>
<th style="text-align: left;">Examples</th>
<th style="text-align: left;">Discussion</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">orderby</td>
<td style="text-align: left;"></td>
<td style="text-align: left;">Sort rows by:</td>
</tr>
<tr class="even">
<td style="text-align: left;"></td>
<td style="text-align: left;">timespancount</td>
<td style="text-align: left;">number of timespans (small to large),
network, station, location, channel, time-range, quality,
sample-rate</td>
</tr>
<tr class="odd">
<td style="text-align: left;"></td>
<td style="text-align: left;">timespancount_desc</td>
<td style="text-align: left;">number of timespans (large to small),
network, station, location, channel, time-range, quality,
sample-rate</td>
</tr>
</tbody>
</table>
<h3 id="additional-parameters-for-the-query-method">Additional
parameters for the query method</h3>
<table>
<colgroup>
<col style="width: 16%" />
<col style="width: 8%" />
<col style="width: 75%" />
</colgroup>
<thead>
<tr class="header">
<th style="text-align: left;">Parameters</th>
<th style="text-align: left;">Example</th>
<th style="text-align: left;">Discussion</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td style="text-align: left;">mergegaps</td>
<td style="text-align: left;">3600</td>
<td style="text-align: left;">The timespans which are separated by gaps
smaller or equal than the given value (in seconds) are merged
together.</td>
</tr>
<tr class="even">
<td style="text-align: left;">show</td>
<td style="text-align: left;">latestupdate</td>
<td style="text-align: left;">Display the last date of data update.</td>
</tr>
</tbody>
</table>
<h2 id="http-post-queries">HTTP POST queries</h2>
<p>The general form of a POST is parameter=value pairs, one per line,
followed by an arbitrary number of channels and, optionally, time window
selection lines:</p>
<p>parameter=&lt;value&gt;<br />
parameter=&lt;value&gt;<br />
parameter=&lt;value&gt;<br />
Net Sta Loc Chan [StartTime EndTime]<br />
Net Sta Loc Chan [StartTime EndTime]<br />
…</p>
<p>Start time and end times can be specified globally, such as</p>
<p>…<br />
start=2020-10-01T00:00:00<br />
end=2020-10-01T00:01:00<br />
Net1 Sta1 Loc1 Chan1<br />
Net2 Sta2 Loc2 Chan2<br />
…</p>
<p>or per line:</p>
<p>…<br />
Net1 Sta1 Loc1 Chan1 2020-10-01T00:00:00 2020-10-01T00:01:00<br />
Net2 Sta2 Loc2 Chan2 2020-10-02T00:00:00 2020-10-02T00:02:00<br />
…</p>
<p>If not given, the start and end times default to the fully available
time range. Additionally, global time ranges can be mixed with
individual time ranges.</p>
<h2 id="date-and-time-formats">Date and time formats</h2>
<pre><code>YYYY-MM-DDThh:mm:ss[.ssssss] ex. 1997-01-31T12:04:32.123
YYYY-MM-DD ex. 1997-01-31 (a time of 00:00:00 is assumed)

where:

YYYY    :: four-digit year
MM      :: two-digit month (01=January, etc.)
DD      :: two-digit day (01 through 31)
T       :: date-time separator
hh      :: two-digit hour (00 through 23)
mm      :: two-digit number of minutes (00 through 59)
ss      :: two-digit number of seconds (00 through 59)
ssssss  :: one to six-digit number of microseconds (0 through 999999)</code></pre>
</body>
</html>
